Type TGui 'Type fr die GUI
	Global sWindowImageName:String
	Global sButtonImageName:String
	Global sINIPath:String = "Data/bin/GUI.ini" 'Unter Umstnden abndern!
	
	Function Render() 'Sorgt dafr, dass die komplette GUI angezeigt wird
		For Local Win:TWindow = EachIn TWindow.lAllWindows 'Alle Fenster werden durchgegangen
			If Win.bActive Then 'Wenn das Fenster nicht aktiv ist, wird es nicht beachtet
				Win.Draw() 'Erst das Fenster malen
				For Local Button:TButton = EachIn Win.lAllButtons
					If Button.bActive
						Button.Draw() 'Alle Buttons die zum Fenster gehren malen
					EndIf
				Next
			EndIf
		Next
	End Function
	
	Function Update(fxPos:Float, fyPos:Float, bMouseHit:Byte) 'Sorgt dafr, dass alle GUI Elemente und Ereignisse verarbeitet werden
		Local Moved:Byte = False
		For Local Win:TWindow = EachIn TWindow.lAllWindows 'Alle Fenster
			If Win.bActive Then 'Nur wenn das Fenster aktiv ist
				If Not Moved Then 'Wenn noch kein anderes Fenster bewegt wurd
					If MouseDown(1) Then 
						Moved = Win.Move(fxPos, fyPos) 'Das Fenster bewegen wenn die Maus gedrckt ist
					EndIf
				EndIf
				For Local Button:TButton = EachIn Win.lAllButtons
					If Button.bActive
						Button.IsOver(fxPos, fyPos)
						Button.Click(bMouseHit) 'Alle zugehrigen Buttons auf Klicks berprfen
					EndIf
				Next
			EndIf
		Next
	End Function
	
	Function Init() 'Bilder der einzelnen GUI-Elemente werden hier geladen
		sWindowImageName = SearchInFile("Windows", "Imagename", sIniPath)
		TLoadedImage.Create(SearchInFile("Windows", "Imagepath", sIniPath), sWindowImageName)
		
		sButtonImageName = SearchInFile("Buttons", "Imagename", sIniPath)
		TLoadedImage.CreateAnimated(SearchInFile("Buttons", "Imagepath", sINIPath), sButtonImageName, Int(SearchInFile("Buttons", "Cellwidth", sIniPath)), Int(SearchInFile("Buttons", "Cellheight", siniPath)), Int(SearchInFile("Buttons", "Totalframes", sINIPath)), 0)
	End Function
	
End Type

Type TWindow 'Klasse fr das Fenster
	Global lAllWindows:TList = New TList 'Alle erstellten Fenster
	
	Field lAllButtons:TList 'Alle zum Fenster gehrigen Buttons
	Field v2dPosition:TVector2D 'Die Position
	Field v2dSize:TVector2D 'Fenstermae
	Field bFullScreen:Byte 'Ob das Fenster den ganzen Bildschirm einnimmt
	Field bActive:Byte 'Ob das Fenster aktiv ist
	Field sName:String 'Name des Fensters
	Field diImage:TDrawnImage
	Field v2dImageScale:TVector2D 'Skalierungsfaktor fr das Bild, falls das Fenster nicht genauso gro ist wie die Grafik
	
	Function GetWindow:TWindow(sName:String) 'Sucht nach einem bestimmten Fenster ber den Namen des Fensters
		For Local win:TWindow = EachIn lAllWindows
			If (Lower(win.sName) = Lower(sName)) Then
				Return win 'Liefert ein Fenster zurck, wenn es gefunden wurde
			EndIf
		Next
		Return Null 'Ansonsten NULL
	End Function
	
	Method New()
		lAllWindows.AddLast(Self) 'Jedes neu erstellte Fenster wird in der Liste gespeichert
	End Method
	
	Method Destroy()
		lAllWindows.Remove(Self) 'Jedes gelschte Fenster wird aus der Liste entfernt
	End Method
	
	Function GetAllowedName:String(sName:String) 'Fenster drfen nicht den gleichen Namen haben
		Local bFoundName:Byte = False
		Local i:Int = 1
		If lAllWindows.IsEmpty() Then Return sName
		Repeat
			For Local wnd:TWindow = EachIn lAllWindows
				If Lower(wnd.sName) = Lower(sName) Then 'Also setzt man einfach ein 1, 12, 123 etc dran
						sName = sName + i
						i = i + 1
				Else
					bFoundName = True
				EndIf
			Next
		Until bFoundName 'irgendwann muss ein Name gefunden werden
		Return sName
	End Function
	
	Function CreateFullscreen:TWindow(sName:String, bActive:Byte) 'Fenster im Vollbildmodus erstellen
		sName = GetAllowedName(sName) 'Erst einen erlaubten Namen geben lassen
		
		Local Window:TWindow = New TWindow
		
		Window.lAllButtons = New TList 'Liste neu erstellen
		Window.bFullScreen = True
		Window.sName = sName
		Window.bActive = bActive
		Window.diImage = Null
		Window.v2dImageScale = Null
		Window.v2dPosition = Null 'Vollbild braucht keine Position
		Window.v2dSize = Null 'Und auch keine Ausmae
		
		Return Window
	End Function
	
	Function Create:TWindow(sName:String, bActive:Byte, fxPos:Float, fyPos:Float, fxSize:Float, fySize:Float) '"Normales" Fenster erstellen
		sName = GetAllowedName(sName) 'Erst einen erlaubten Namen finden
		
		Local Window:TWindow = New TWindow
		
		Window.lAllButtons = New TList
		Window.bFullscreen = False
		Window.sName = sName
		Window.bActive = bActive
		Window.diImage = TDrawnImage.Create(TLoadedImage.GetImage(TGUi.sWindowImageName))
		Window.v2dPosition = TVector2d.Create(fxPos, fyPos) 'Die Positions festlegen
		Window.v2dSize = TVector2d.Create(fxSize, fySize) 'Die Gre festlegen
		Window.v2dImageScale = TVector2D.Create(Float(fxSize / Float(Window.diImage.iWidth)), Float(fysize / Float(Window.diImage.iHeight)))
		
		Return Window
	End Function
	
	Method Draw() 'Hiermit wird das Fenster gezeichnet
		If (Not bFullscreen)
			SetColor(255,255,255)
			SetScale(v2dImageScale.Get_X(), v2dImageScale.Get_Y())
			diImage.Draw(v2dPosition)
			SetScale(1.0,1.0)
			SetColor(10,10,10) 'Die Schrift ist schwarz
			DrawText(sName, v2dPosition.Get_X() - v2dSize.Get_X()/3 - TextWidth(sName)/2, v2dPosition.Get_y() - v2dSize.Get_y()/2 + v2dSize.get_y()/10 - TextHeight(sName)/2)
			SetColor(255,255,255)
		EndIf
	End Method
	
	Method Move:Byte(fxPos:Float, fyPos:Float) 'Das Fenster bewegen
		If (Not bFullscreen) Then 'Das geht nur, wenn das Fenster kein Vollbild ist
			If (InRectangle(fxPos, fyPos, v2dPosition.Get_x()-v2dSize.Get_X()/2, v2dPosition.Get_y()-v2dSize.Get_Y()/2, v2dSize.Get_x(), v2dSize.Get_y()/7)) Then 'Wenn die Maus sich auf der Statusleiste befindet
				v2dPosition = Tvector2d.Create(fxpos, fyPos + v2dSize.Get_Y()/2 - 5) 'Position verndern
				For Local Button:TButton = EachIn lAllButtons 'Alle zugehrigen Buttons mssen auch versetzt werden
					Button.v2dPosition = TVector2d.Create(v2dPosition.Get_x()-v2dSize.Get_X()/2 + Button.v2dRelativePosition.Get_X(), v2dPosition.Get_y()-v2dSize.Get_Y()/2 + Button.v2dRelativePosition.Get_Y())
				Next
				Return True
			EndIf
		EndIf
		Return False
	End Method
End Type

Type TButton 'Type fr die Buttons
	Global lAllButtons:TList = New TList 'In der Liste werden alle Buttons gespeichert
	Global v2dSize:TVector2D = TVector2D.Create(150, 50) 'Alle Buttons haben die gleiche Gre
	
	Field fpFunction:Int() 'Funktionspointer
	Field v2dPosition:TVector2D, v2dRelativePosition:TVector2D 'echte Bildschirmpositions und die relative Bildschirmposition (auf Fenstern)
	Field sName:String 'Name und Beschriftung des buttons
	Field bActive:Byte 'Ob der Button aktiv ist
	Field bOver:Byte
	Field diImage:TDrawnImage
	Field v2dImageScale:Tvector2D
	Field wParentWindow:TWindow 'Das Fenster zu dem der Button gehrt
	
	Method New()
		lAllButtons.Addlast(Self) 'Button wird der Liste automatisch hinzugefgt
	End Method
	
	Method Destroy()
		lAllButtons.Remove(Self) 'Buttons wird automatisch von der Liste entfernt
	End Method
	
	Function Create:TButton(sName:String, bActive:Byte, fxPos:Float, fyPos:Float, fpfunction:Int(), sParentName:String) 'Konstruktor
		Local Button:TButton = New TButton
			
		Local wParent:TWindow
		
		For Local Win:TWindow = EachIn TWindow.lAllwindows
			If Lower(Win.sName) = Lower(sParentName) Then wParent = Win 'Das richtige Fenster wird gesucht
		Next
			
		Button.sName = sName
		Button.bActive = bActive
		Button.wParentWindow = wParent
		Button.fpFunction = fpfunction
		Button.bOver = False
		Button.diImage = TDrawnImage.Create(TLoadedImage.GetImage(TGUi.sButtonImageName))
		Button.v2dRelativePosition = TVector2D.Create(fxPos, fyPos) 'Relative Position bleibt immer gleich
		Button.v2dImageScale = TVector2D.Create(Float(v2dSize.Get_X() / Float(Button.diImage.iWidth)), Float(v2dSize.Get_Y() / Float(Button.diImage.iHeight)))
		
		If (wParent.v2dPosition = Null) Then 'Wenn das Parent-Fenster ein Vollbildfenster ist
			Button.v2dPosition = TVector2D.Create(fxPos, fyPos) 'Dann wird der Button direkt im Fenster ausgerichtet
		Else
			'Ansonsten wird der Button relativ zum Fenster ausgerichtet
			Button.v2dPosition = TVector2D.Create(wParent.v2dPosition.Get_x()-wParent.v2dSize.Get_x()/2 + fxPos, wParent.v2dPosition.Get_y()-wParent.v2dSize.Get_y()/2 + fyPos)
		EndIf
		
		wParent.lAllButtons.AddLast(Button) 'Den Button nocht in die Liste des Fensters einfgen
			
		Return Button
	End Function
	
	Method Draw() 'Hier wird der Button gemalt
		SetColor(255, 255, 255)
		SetScale(v2dImageScale.get_X(), v2dImageScale.Get_Y())
		diImage.Draw(v2dPosition)
		SetScale(1.0, 1.0)
		SetColor(10, 10, 10)
		DrawText(sname, v2dPosition.Get_x() - TextWidth(sName)/2, v2dPosition.Get_y() - TextHeight(sName)/2)
		SetColor(255,255,255)
	End Method
	
	Function GetButton:TButton(sWindowName:String, sButtonName:String) 'Einen bestimmen Button finden
		For Local win:TWindow = EachIn TWindow.lAllWindows
			If (Lower(win.sName) = Lower(sWindowName)) Then
				For Local Button:TButton = EachIn win.lAllButtons
					If (Lower(Button.sName) = Lower(sButtonName)) Then
						Return Button
					EndIf
				Next
			EndIf
		Next
		Return Null
	End Function
	
	Method IsOver(fxPos:Float, fyPos:Float) 'berprft ob die Maus innerhalb des Buttons ist
		If (InRectangle(fxpos, fypos, v2dPosition.Get_x()-v2dSize.Get_X()/2, v2dPosition.Get_y()-v2dSize.get_y()/2, TButton.v2dSize.Get_x(), TButton.v2dSize.Get_y())) Then
			If bover = False Then diImage.AnimateManual()
			bOver = True
		Else
			If bOver Then diImage.AnimateManual()
			bOver = False
		EndIf
	End Method
	
	Method Click(Hit:Byte) 'Funktion die den Funktionspointer des Buttons aufruft, wenn darauf geklickt wird
		If bOver Then
			If (Hit) Then
				fpFunction
			EndIf
		EndIf
	End Method
End Type