Function GetValue:String(sLine:String) 'Gibt den Wert, also das was rechts vom "=" steht zurck
	
	
	If Instr(sLine, "=") > 0 Then
		Return Right(sLine, Len(sLine) - Instr(sLine, "="))
	Else
		Return ""
	EndIf
	
End Function

Function GetLeftPart:String(sLine:String) 'Gibt die Bezeichnung, also das was links vom "=" steht zurck
	If Instr(sLine, "=") > 0 Then
		Return Left(sLine, Instr(sLine, "=") - 1)
	Else
		Return ""
	EndIf
End Function

Function SearchValue:String(sSearchTerm:String, fileINI:TStream, sFile:String) 'Sucht nach einem Schlsselwort, aber nur in einer Sektion

	Local sValue:String, sLine:String
	
	While Not Eof(fileINI)	
		sLine = ReadLine(fileINI)
		If Lower(Trim(GetLeftPart(sLine))) = Lower(sSearchTerm) Then
			Return GetValue(sLine)
		EndIf
		If Left(sLine, 1) = "[" Then RuntimeError("Wert '" + sSearchTerm + "' konnte in dieser Sektion nicht gefunden werden")
	Wend
	RuntimeError("Wert '" + sSearchTerm + "' in '" + sFile + "' konnte nicht gefunden werden")
		
End Function

Function SearchInFile:String(sSection:String, sSearchTerm:String, sFile:String) 'Sucht in der Datei zuerst nach einer Sektion und dann nach dem Schlsselwort
	
	Local sValue:String, sLine:String, fileINI:TStream
	
	sSection = "[" + sSection + "]"
	
	If FileType(sFile) = 1 Then	
		fileINI = ReadFile(sFile)
		While Not Eof(fileINI)
			sLine = ReadLine(fileINI)
			If Lower(sLine) = Lower(sSection) Then
				sValue = SearchValue(sSearchTerm, fileINI, sFile)
				CloseFile fileINI
				Return Trim(sValue:String)
			EndIf
		Wend
		RuntimeError("Sektion '" + sSection + "' in '" + sFile + "' konnte nicht gefunden werden")
	Else
		RuntimeError "Datei '" + sFile + "' existiert nicht."
	EndIf
	
End Function
